#!/usr/bin/perl

use strict;
use warnings;

#############################################
# change the values of $dbfile to the absolute path to your
# own database file and do the same for $dbcommand to the
# absolute path to your sqlite3 executable
#
# ALSO!  Be sure to change the path variables in the
# monstermangler.tf script and verify the correct
# path to sqlite3 in the 'sqlite' shell script


my $dbfile="/home/hair/tf-dir/monstermangler.db";
my $dbcommand="/usr/bin/sqlite3";

print ("WARNING: This could take some time to run depending on how many/how large\n");
print ("log files you are parsing through.  Hit Ctrl-C now to abort.\n");
print ("This script will search the given directory for all files ending with '.log'\n");
print ("and search through them for any output from the 'party kills' command and\n");
print ("import that data into the monstermangler database\n\n");
print ("Enter path to log files: ");
my $outputdir = <STDIN>;
chop($outputdir);
opendir(LOGDIR, "$outputdir") or die("Unable to open log directory.\n");
my @ulogdir = grep(/(.*)log/,readdir(LOGDIR));
my @logdir = sort (@ulogdir);
my $file = undef;
print ("Starting import...\n");
foreach $file (@logdir) {
	open (LOG, "<$outputdir/$file") or die("Unable to open $file\n");
	print ("Processing file $outputdir/$file\n");
	while (<LOG>) {
		if ($_ =~ m/^\| ([0-9]+)\:([0-9]+)([ ]+)([0-9]+)\: ([A-Za-z, '\(\)-]+)([ ]+)\|$/ ) {
			my $exp = $4;
			my $pk = rtrim($5);
			my $sql = "\"select * from MOBS where NAME like \\\"$pk\\\";\"";
			my $result = qx/$dbcommand $dbfile $sql/;
			if ($result ne "") {
				my @fields = split(/\|/, $result);
				my $lexp = $fields[2];
				my $hexp = $fields[3];
				if ($exp < $lexp) {
					my $sql = "\"update MOBS set LEXP = $exp where NAME = \\\"$pk\\\";\"";
					system("$dbcommand $dbfile $sql");
				}
				elsif ($exp > $hexp) {
					my $sql = "\"update MOBS set HEXP = $exp where NAME = \\\"$pk\\\";\"";
					system("$dbcommand $dbfile $sql");
				}
			}
			else {
				my $sql = "\"insert into MOBS (NAME,LEXP,HEXP) values (\\\"$pk\\\",$exp,$exp);\"";
				system("$dbcommand $dbfile $sql");
			}
		}
	}
}
closedir(LOGDIR);
print ("Import complete.\n");

sub rtrim { my $s = shift; $s =~ s/\s+$//;       return $s };

