;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;; monstermangler.tf 
;; Original idea by Tyril
;; Converted to SQLite3 by Hair
;;
;; You will need to change the lines for DBFILE and SCRIPTFILE
;; below.  You will also need to look at mmport.pl and mminit.pl
;; and change the lines for $dbfile and $dbcommand AND you
;; will need to edit the 'sqlite' bash script to make sure
;; it calls sqlite3 from the proper location

;; Set the path to your db file here
/SET DBFILE=/home/hair/tf-dir/monstermangler.db

;; Set the path to the script that calls sqlite3 here
/SET SCRIPTFILE=/home/hair/tf-dir/sqlite

;; Read in any string, check its color, if monster colored, look it up 
;; Then report with same color: Flipper [900k,1200k] flip 
/DEF -F -i -mregexp -t"^([A-Za-z,. \'\-\(\)\<\>=]*)$" mm_monster_exp_substitution = \
	/LET _mobDisplayName=%{P1} %; \
	/LET _mobColor=$[encode_attr(%{P1})] %; \
;; IF YOU HAVE CHANGED DEFAULT MONSTER COLORATION !!!
;; Change the regmatch below to reflect this.  Default is bright green for calm mobs
;; and bright red for aggro mobs. I have set my woundedmons and woundedaggrmons to
;; dim colors to make easy identification of wounded mobs and this statement catches both
;; bright and dim colors
	/IF (!regmatch("^@{B?C(green|red)}.+@{n}$", %{_mobColor})) \
		/return 0%; \
	/ELSE \
		/LET _mobName=$[strip_attr(%{_mobDisplayName})] %; \
		/IF (regmatch("( \(undead\)| \<\-?\=?wrapped\=?\-?\>| \(bleeding\))", %{_mobName})) \
			/LET _mobName=%{PL} %; \
		/ENDIF %; \
		/IF (strlen(%{_mobName} > 60)) \
			/LET _mobTrunc=$[substr(%{_mobName},0,60)] %; \
		/ELSE /LET _mobTrunc=%{_mobName} %; \
		/ENDIF %; \
		/LET _sql=select * from MOBS where NAME like \\"%{_mobTrunc}\\"; %; \
		/LET _mobFull=$(/QUOTE -S /ECHO !bash %{SCRIPTFILE} %{DBFILE} "%{_sql}") %; \
		/IF (regmatch("([0-9]*)\|(.*)\|([0-9]*)\|([0-9]*)\|", %{_mobFull})) \
			/LET _mobExp1=%{P3} %; \
			/IF (%{_mobExp1} > 999) \
				/LET _mobExp1=$[%{_mobExp1} / 1000]k %; \
			/ENDIF %; \
			/LET _mobExp2=%{P4} %; \
			/IF (%{_mobExp2} > 999) \
				/LET _mobExp2=$[%{_mobExp2} / 1000]k %; \
			/ENDIF %; \
			/LET _mobAddition=%{PR} %; \
			/SUBSTITUTE -p %{_mobDisplayName} @{BCwhite}[%{_mobExp1},%{_mobExp2}] @{n}@{BCred}%{_mobAddition}@{n} @{BCblack}(id: %{P1})@{n} %; \
		/ENDIF%; \
	/ENDIF

;; mobnote <id> <note> or mobnote <id> clear
;; Allows you to add notes to monster entries.  If no ID is displayed on look then monster is
;; not in the database.
/DEF -i -ag -h"send {mobnote}*" mm_mobnote_insert = \
	/IF (%{-1} !~ "") \
		/IF (%{2} > 0) \
			/IF (%{-2} =~ "clear") \
				/LET _sql=update MOBS set NOTES = \\"\\" where ID = %{2}; %; \
				/ECHO -p @{Cyellow}Clearing notes for ID %{2} %; \
			/ELSE \
				/LET _sql=update MOBS set NOTES = \\"%{-2}\\" where ID = %{2}; %; \
				/ECHO -p @{Cyellow}Inserted note into ID %{2}@{n} %; \
			/ENDIF %; \
			/QUOTE -S /ECHO !bash %{SCRIPTFILE} %{DBFILE} "%{_sql}" %; \
		/ELSE \
			/ECHO -p @{Cyellow}Usage: mobnote <id> <note> OR mobnote <id> clear@{n} %; \
		/ENDIF %; \
	/ELSE \
		/ECHO -p @{Cyellow}Usage: mobnote <id> <note> OR mobnote <id> clear@{n} %; \
	/ENDIF

;; Parses and gags output of 'party kills' to update or add lines in the database.
/DEF -i -ag -h"send {pk}" mm_get_party_kills = \
	/DEF -i -n1 -ag -t",-----------------------------------------------------------------------------." mm_pkills_gag1 %; \
	/DEF -i -n1 -ag -t"`-----------------------------------------------------------------------------'" mm_pkills_gag2 = \
		/UNDEF mm_pkills_gag4 %; \
	/DEF -1 -mregexp -n1 -ag -t"^^This party has killed (.*) \\(avg exp/mon: ([0-9]*)\\)\\.$$" mm_pkills_gag3 %; \
	/DEF -i -mregexp -ag -t"^^\\| ([0-9]+)\\:([0-9]+)([ ]+)([0-9]+)\\: (.*)([ ]+)\\|$$" mm_pkills_gag4 = \
		/LET _name=$$[trim(%%{P5})] %%; \
		/LET _exp=%%{P4} %%; \
		/LET _sql=select * from MOBS where NAME like \\\\"%%{_name}\\\\"; %%; \
		/LET _mobFull=$$(/QUOTE -S /ECHO !bash %{SCRIPTFILE} %{DBFILE} "%%{_sql}") %%; \
		/IF (regmatch("([0-9]*)\\|(.*)\\|([0-9]*)\\|([0-9]*)\\|", %%{_mobFull})) \
			/IF (%%{_exp} < %%{P3}) \
				/LET _sql=update MOBS set LEXP = %%{_exp} where NAME = \\\\"%%{_name}\\\\"; %%; \
				/SYS %{SCRIPTFILE} %{DBFILE} "%%{_sql}" %%; \
			/ELSEIF (%%{_exp} > %%{P4}) \
				/LET _sql=update MOBS set HEXP = %%{_exp} where NAME = \\\\"%%{_name}\\\\"; %%; \
				/SYS %{SCRIPTFILE} %{DBFILE} "%%{_sql}" %%; \
			/ENDIF %%; \
		/ELSE \
			/LET _sql=insert into MOBS (NAME,LEXP,HEXP) values (\\\\"%%{_name}\\\\",%%{_exp},%%{_exp}); %%; \
			/SYS %{SCRIPTFILE} %{DBFILE} "%%{_sql}" %%; \
		/ENDIF %; \
	/SEND @@party kills

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Written by Xyloid in his
;; sttrep2.tf scripts for miscelleanous
;; string handling functions
;; Removes whitespace from the end of a string

/def trim = \
  /let v1=%*%;\
  /if (strlen(v1)<1) /return ""%;/endif%;\
  /let s1=$[strchr(v1," ")]%;\
  /while (s1 == 0) \
    /let v1=$[substr(v1,1)]%;\
    /if (strlen(v1)<1) /return ""%;/endif%;\
    /let s1=$[strchr(v1," ")]%;\
  /done%;\
  /let s1=$[strrchr(v1," ")]%;\
  /while (s1 == (strlen(v1)-1)) \
    /let v1=$[substr(v1,0,strlen(v1)-1)]%;\
    /if (strlen(v1)<1) /return ""%;/endif%;\
    /let s1=$[strrchr(v1," ")]%;\
  /done%;\
  /return "%{v1}"

